#!/bin/bash
# {{ ansible_managed }}
#
# Create a monitoring report of the import processes and send via mail.
#
# ERRORS - number of processing errors in the process
# FAILURES - number of conspicuities in the data 
#

FAILURE_BOUND={{ search_index_monitoring_import_failure_bound }} # send report when number of failures is greater than or equal to this bound
MAIL_RECIPIENTS={{ search_index_monitoring_recipients }}
MAIL_FROM_ADDRESS={{ search_index_monitoring_from_address }}

{% if etl_install %}ETL_REPORT=$({{ base_dir }}/bin/monitoring-etl.sh)
{% endif %}
{% if import_scripts_install %}IMPORTSCRIPT_REPORT=$({{ base_dir }}/bin/monitoring-import-scripts.sh)
{% endif %}
{% if internationalization_tool_install %}INTERNATIONALIZATION_REPORT=$({{ base_dir }}/bin/monitoring-internationalization.sh)
{% endif %}
{% for metadata_report in (search_index_monitoring_metadata_reports | default([], true)) %}
METADATA_REPORT_{{ loop.index }}=$(curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST --header 'Content-Type: application/json' --header 'Accept: application/json' "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/{{ elasticsearch_metadata_index_alias_name }}/_search" -d '{{ metadata_report.query }}' | jq -r '{{ metadata_report.jq_selection | default('.aggregations.providers.buckets[] | "\(.key): \(.doc_count)"', true) }}')
{% endfor %}

{% if etl_install %}
ETL_PROCESSES=$(echo "$ETL_REPORT" | grep 'Import channel' | wc -l)
ETL_ERRORS=$(echo "$ETL_REPORT" | grep 'FAILED:' | wc -l)
ETL_FAILURES=$(echo "$ETL_REPORT" | gawk -v failures='0' 'match($0, /SUCCESS: (.+), FAIL-PROCESS: (.+), FAIL-VALIDATION: (.+), FAIL-WRITE: (.+)/, a) {failures = failures + (a[2] == "n/a" ? 0 : a[2]) + a[3] + a[4]}END{print failures}')
ETL_SUCCESSES=$(echo "$ETL_REPORT" | gawk -v successes='0' 'match($0, /SUCCESS: (.+), FAIL-PROCESS: (.+), FAIL-VALIDATION: (.+), FAIL-WRITE: (.+)/, a) {successes = successes + a[1]}END{print successes}')
{% else %}
ETL_PROCESSES=0
ETL_ERRORS=0
ETL_FAILURES=0
ETL_SUCCESSES=0
{% endif %}

{% if import_scripts_install %}
IMPORTSCRIPT_PROCESSES=$(echo "$IMPORTSCRIPT_REPORT" | grep 'Import channel' | wc -l)
IMPORTSCRIPT_ERRORS=$(echo "$IMPORTSCRIPT_REPORT" | grep 'FAILED:' | wc -l)
IMPORTSCRIPT_FAILURES=$(echo "$IMPORTSCRIPT_REPORT" | gawk -v failures='0' 'match($0, /SUCCESS: (.+), FAIL: (.+)/, a) {failures = failures + a[2]}END{print failures}')
IMPORTSCRIPT_SUCCESSES=$(echo "$IMPORTSCRIPT_REPORT" | gawk -v successes='0' 'match($0, /SUCCESS: (.+), FAIL: (.+)/, a) {successes = successes + a[1]}END{print successes}')
{% else %}
IMPORTSCRIPT_PROCESSES=0
IMPORTSCRIPT_ERRORS=0
IMPORTSCRIPT_FAILURES=0
IMPORTSCRIPT_SUCCESSES=0
{% endif %}

REPORT="{% if etl_install %}$ETL_REPORT
{% endif %}
{% if import_scripts_install %}$IMPORTSCRIPT_REPORT
{% endif %}
{% if internationalization_tool_install %}

Internationalization-Tool:
$INTERNATIONALIZATION_REPORT
{% endif %}

{% for metadata_report in (search_index_monitoring_metadata_reports | default([], true)) %}
-----------------------
{{ metadata_report.description }}
$METADATA_REPORT_{{ loop.index }}

{% endfor %}
"
PROCESSES=$(($ETL_PROCESSES+$IMPORTSCRIPT_PROCESSES))
ERRORS=$(($ETL_ERRORS+$IMPORTSCRIPT_ERRORS))
FAILURES=$(($ETL_FAILURES+$IMPORTSCRIPT_FAILURES))
SUCCESSES=$(($ETL_SUCCESSES+$IMPORTSCRIPT_SUCCESSES))

SUBJECT="{{ application_name }} Import Monitoring - processes $(($PROCESSES-$ERRORS)) ok, $ERRORS error (data $SUCCESSES ok, $FAILURES failed)"

if [ "$FAILURES" -ge "$FAILURE_BOUND" ] || [ "$ERRORS" -gt "0" ]; then
  echo "Sending report ($SUBJECT)"
  echo "$REPORT" | mail -s "$SUBJECT" -r $MAIL_FROM_ADDRESS $MAIL_RECIPIENTS
else
  echo "Don't send report ($SUBJECT)"
fi
